
import os



def parse_file( infile, workload_idx_to_config_to_fixed, workload_idx_to_config_to_madeye , workload_idx_to_config_to_dynamic,  s, k):
    with open(infile , 'r') as f:
        workload_idx = -1
        for line in f.readlines():
            line = line.strip()
            if line.startswith('WORKLOAD'):
                workload_idx += 1
                if workload_idx not in workload_idx_to_config_to_dynamic:
                    workload_idx_to_config_to_dynamic[workload_idx] = {} 
                    workload_idx_to_config_to_fixed[workload_idx] = {} 
                    workload_idx_to_config_to_madeye[workload_idx] = {} 
                if (s,k) not in workload_idx_to_config_to_dynamic[workload_idx]:
                    workload_idx_to_config_to_dynamic[workload_idx][(s,k)] = [] 
                    workload_idx_to_config_to_fixed[workload_idx][(s,k)] = [] 
                    workload_idx_to_config_to_madeye[workload_idx][(s,k)] = [] 

            if line.startswith('fixed accuracy  '):
                data = line
                data = data.replace('fixed accuracy  ', '')
                workload_idx_to_config_to_fixed[workload_idx][(s,k)].append( float( data)   )
            if line.startswith('MadEye  '):
                data = line
                data = data.replace('MadEye  ', '')
                workload_idx_to_config_to_madeye[workload_idx][(s,k)].append(float(data)   )
            if line.startswith('DYnamic score  '):
                data = line
                data = data.replace('DYnamic score  ', '')
                workload_idx_to_config_to_dynamic[workload_idx][(s,k)].append( float( data), )

workload_idx_to_config_to_dynamic = {}
workload_idx_to_config_to_fixed = {}
workload_idx_to_config_to_madeye = {}

for s in [ 1, 2, 3]:
    for k in [ 5, 7, 9, 11, 13, 15, 17]:
        dt1_indir = 'data/2-13/seattle-dt-1/fig14-config-results'
        dt1_infile = f'seattle-dt-1-{s}-{k}.txt'
        parse_file(os.path.join(dt1_indir, dt1_infile), workload_idx_to_config_to_fixed, workload_idx_to_config_to_madeye , workload_idx_to_config_to_dynamic,  s, k)

        ave_indir = 'data/2-13/seattle-ave/fig14-config-results'
        ave_infile = f'seattle-ave-{s}-{k}.txt'
        parse_file(os.path.join(ave_indir, ave_infile), workload_idx_to_config_to_fixed, workload_idx_to_config_to_madeye , workload_idx_to_config_to_dynamic,  s, k)


        dt2_indir = 'data/2-13/seattle-dt-2'
        dt2_infile = f'seattle-dt-2-{s}-{k}.txt'
        parse_file(os.path.join(dt2_indir, dt2_infile), workload_idx_to_config_to_fixed, workload_idx_to_config_to_madeye , workload_idx_to_config_to_dynamic,  s, k)



        city_indir = 'data/2-13/seattle-city/'
        city_infile = f'seattle-city-{s}-{k}.txt'
        parse_file(os.path.join(city_indir, city_infile), workload_idx_to_config_to_fixed, workload_idx_to_config_to_madeye , workload_idx_to_config_to_dynamic,  s, k)
#
#        traf_indir = 'data/seattle-traffic/config-results'
#        traf_infile = f'seattle-traffic-{s}-{k}.txt'
#        parse_file(os.path.join(traf_indir, traf_infile), workload_idx_to_config_to_fixed, workload_idx_to_config_to_madeye , workload_idx_to_config_to_dynamic,  s, k)
       
with open('saved_data.txt', 'w') as f_out:
    for w_idx in workload_idx_to_config_to_madeye:
        video_idx_to_data = {}

        for (s,k) in workload_idx_to_config_to_madeye[w_idx]:
            for i in range(0, len(workload_idx_to_config_to_madeye[w_idx][(s,k)])):
                madeye_accuracy = workload_idx_to_config_to_madeye[w_idx][(s,k)][i]
                fixed_accuracy  = workload_idx_to_config_to_fixed[w_idx][(s,k)][i]
                dynamic_accuracy  = workload_idx_to_config_to_dynamic[w_idx][(s,k)][i]
                if i not in video_idx_to_data:
                    video_idx_to_data[i] = []
                video_idx_to_data[i].append( ( (madeye_accuracy - fixed_accuracy) , s, k) )

        fixed_data = []
        madeye_data = []
        dynamic_data = []
        print('WORKLOAD ', w_idx)
        for video_idx in video_idx_to_data:
            video_idx_to_data[video_idx].sort(key=lambda x: x[0])


            idx_p = int(len(video_idx_to_data[video_idx]) * 0.5 )
#            idx_p1 = int(len(video_idx_to_data[video_idx]) * 0.94 )
#            idx_p2 = int(len(video_idx_to_data[video_idx]) * 0.99 )
#            idx_p = idx_p2
#            min_diff = 100000
#            for i in range(idx_p1, idx_p2):
#                (_, s, k) = video_idx_to_data[video_idx][i]
#                current_diff = workload_idx_to_config_to_dynamic[w_idx][(s,k)][video_idx] - workload_idx_to_config_to_madeye[w_idx][(s,k)][video_idx]
#                if current_diff < min_diff:
#                    idx_p = i 
#                    min_diff = current_diff 

            (diff, s, k) = video_idx_to_data[video_idx][idx_p]
            fixed_data.append( workload_idx_to_config_to_fixed[w_idx][(s,k)][video_idx])
            madeye_data.append( workload_idx_to_config_to_madeye[w_idx][(s,k)][video_idx])
            dynamic_data.append( workload_idx_to_config_to_dynamic[w_idx][(s,k)][video_idx])
#            print('FIxed ' ,workload_idx_to_config_to_fixed[w_idx][(s,k)][video_idx])
#            print('MadEye ', workload_idx_to_config_to_madeye[w_idx][(s,k)][video_idx])

        f_out.write(f'fixed_w{w_idx+1} = {fixed_data}\n')
        f_out.write(f'madeye_w{w_idx+1} = {madeye_data}\n')
        f_out.write(f'dynamic_w{w_idx+1} = {dynamic_data}\n')


