import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
  
# No of Data points
  
  
fig, ax = plt.subplots()

fig.set_size_inches(5, 4)

# vid1 corresponds to NAS1, vid2 to NAS2, etc.
vid1 =[1, 1, 2, 1, 2, 1, 1, 1, 2, 1, 1, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 1, 2, 2, 1, 1, 2, 1, 2, 2, 1, 1, 1, 2, 1, 1, 2, 1, 2, 1, 2, 1, 2, 2, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 2, 3, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 2, 2, 2, 2, 1, 1, 1, 1, 2, 1, 2, 3, 1, 1, 1, 1, 1, 3, 2, 2, 1, 2, 2, 1, 1, 1, 2, 2, 2, 2, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 3, 2, 2, 2, 2, 1, 2, 1, 2, 1, 2, 1, 1, 2, 2, 1, 3, 3, 1, 1, 1, 1, 2, 2, 2, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1      , 1, 1, 1, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1, 1, 2, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 2, 1, 2, 1, 1, 2, 1, 1, 1, 2] 
vid2 = [1, 1, 2, 1, 1, 1, 1, 2, 2, 2, 1, 2, 1, 1, 1, 1, 1, 2, 2, 2, 2, 1, 2, 2, 3, 1, 1, 2, 3, 2, 3, 1, 1, 2, 2, 1, 2, 2, 2, 1, 1, 1, 2, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1,      2, 1, 1, 1, 3, 2, 2, 1, 2, 1, 2, 1, 1, 2, 1, 1, 3, 1, 2, 1, 4, 2, 2, 1, 1, 1, 2, 1, 1, 1, 3, 1, 1, 1, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 1, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1,      1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1, 2, 1, 1, 2, 2, 3, 1, 1, 1, 2, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 1, 1, 2, 1, 2, 1, 3, 1     , 1, 2, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 2, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 2, 2, 1, 2, 1, 1, 2, 1, 1, 1, 2, 5, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 2, 1, 1, 1, 1, 3, 2, 2, 1, 2,      2, 1, 1, 1, 1, 2, 2, 1, 2, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 2, 2, 3, 1, 2, 2, 1, 2, 2, 2, 1, 1, 2, 2, 1, 1, 2, 1, 1, 2, 1, 3, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1]
vid3 = [2, 1, 2, 1, 1, 1, 1, 1, 2, 1, 2, 1, 2, 2, 1, 6, 2, 2, 1, 1, 1, 1, 1, 2, 2, 1, 3, 2, 2, 1, 1, 1, 1, 2, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 2, 2      , 2, 2, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 2      , 3, 1, 2, 2, 3, 1, 1]
vid4 = [1, 1, 2, 1, 1, 1, 2, 2, 3, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 2, 2, 1, 1, 1, 1, 2, 1, 2, 1, 2, 1, 1, 1, 1, 1, 1, 1, 3, 4, 2, 2, 1, 2, 2, 3, 1, 1, 1, 2, 2, 2, 2, 1, 1, 1,      1, 3, 3, 2, 1, 1, 3, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 3, 3, 2, 2, 2, 1, 2, 1, 1, 1, 1, 4, 2, 8, 1, 1, 1, 6, 1, 9, 1, 1, 2, 5, 2, 2, 1, 3, 2, 2, 1, 1, 1, 2, 2, 2, 3, 5, 1, 2,      2, 2, 3, 1, 1, 2, 4, 4, 1, 2, 1, 2, 1, 2, 2, 2, 2, 1, 1, 2, 2, 3, 3, 1, 1, 1, 2, 2, 1, 2, 2, 1, 1, 1, 3, 2, 1, 2, 1, 1, 2, 2, 1, 2, 1, 2, 1, 1, 2, 1, 1, 2, 2, 1, 1, 3, 2, 2, 1, 1, 2, 1, 2     , 1, 1, 1, 1, 1, 2, 1, 1, 1, 3, 2, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1, 2, 1, 2, 1, 3, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 2]
vid1 = [item for item in vid1 if item <= 6] 
vid2 = [item for item in vid2 if item <= 6] 
vid3 = [item for item in vid3 if item <= 6] 
vid4 = [item for item in vid4 if item <= 6] 

vid1_x = np.sort(vid1)
vid1_y = np.arange(len(vid1_x))/float(len(vid1_x))
plt.plot(vid1_x, vid1_y, label="Video 1")


vid2_x = np.sort(vid2)
vid2_y = np.arange(len(vid2_x))/float(len(vid2_x))
plt.plot(vid2_x, vid2_y, label="Video 2")

vid3_x = np.sort(vid3)
vid3_y = np.arange(len(vid3_x))/float(len(vid3_x))
plt.plot(vid3_x, vid3_y, label="Video 3")

vid4_x = np.sort(vid4)
vid4_y = np.arange(len(vid4_x))/float(len(vid4_x))
plt.plot(vid4_x, vid4_y, label="Video 4")

ax.set_xlabel('Optimal Orientation Duration (s)', fontsize=10)
#ax.set_title('Orientation duration', fontsize=12)
ax.set_ylabel('CDF', fontsize=10)
#ax.set_xticks(x, labels, fontsize=14)
ax.legend()

plt.savefig('cdf.pdf')
