import matplotlib.pyplot as plt
import numpy as np


def median(l):
    l.sort()
    idx = int(len(l) / 2)
    return l[idx]

def low(l):
    l.sort()
    idx = int(len(l) / 4)
    return l[idx]

def high(l):
    l.sort()
    idx = int(len(l) * 0.75)
    return l[idx]

labels = [ 'YOLO\n(people)', 'Tiny YOLO\n(people)', 'SSD\n(people)', 'FRCNN\n(people)']


# FIXED RESULTS
data_yolo_people_fixed = [
    0.094791666, # seattle-dt-1
    0.15651211, # seattle-traffic
    0.20961261, # seattle-dt-2
]
data_tiny_people_fixed = [
    0.06626506, # seattle-dt-1 
    0.115769796, # seattle-traffic
    0.24149117, # seattle-dt-2
]
data_ssd_people_fixed = [
    0.07936508, # seattle-dt-1 
    0.13399152, # seattle-traffic
    0.26553985, # seattle-dt-2
]
data_frcnn_people_fixed = [
    0.098773845, # seattle-dt-1 
    0.11304712, # seattle-traffic
    0.17743838, # seattle-dt-2
]

# BEST RESULTS
data_yolo_people_best = [
    0.396875, # seattle-dt-1 
    0.94837344, # seattle-traffic
    0.53870946, # seattle-dt-2
]
data_tiny_people_best = [
    0.4683735, # seattle-dt-1 
    0.98723567, # seattle-traffic
    0.9902486, # seattle-dt-2
]
data_ssd_people_best = [
    0.5941043, # seattle-dt-1 
    1, # seattle-traffic
    0.946961, # seattle-dt-2
]
data_frcnn_people_best = [
    0.33719346, # seattle-dt-1 
    0.6788716, # seattle-traffic
    0.4840987, # seattle-dt-2
]


fixed = [
median(data_yolo_people_fixed), # YOLO (people)
median(data_tiny_people_fixed), # Tiny YOLO (people)
median(data_ssd_people_fixed), # SSD (people)
median(data_frcnn_people_fixed), # FRCNN(people)
]


best = [ 
median(data_yolo_people_best), # YOLO (people)
median(data_tiny_people_best), # Tiny YOLO (people)
median(data_ssd_people_best), # SSD (people)
median(data_frcnn_people_best), # FRCNN(people)
]

fixed_min = [
low(data_yolo_people_fixed), # YOLO (people)
low(data_tiny_people_fixed), # Tiny YOLO (people)
low(data_ssd_people_fixed), # SSD (people)
low(data_frcnn_people_fixed), # FRCNN(people)
]
best_min = [
low(data_yolo_people_best), # YOLO (people)
low(data_tiny_people_best), # Tiny YOLO (people)
low(data_ssd_people_best), # SSD (people)
low(data_frcnn_people_best), # FRCNN(people)
]
fixed_max = [
high(data_yolo_people_fixed), # YOLO (people)
high(data_tiny_people_fixed), # Tiny YOLO (people)
high(data_ssd_people_fixed), # SSD (people)
high(data_frcnn_people_fixed), # FRCNN(people)
]

best_max = [
high(data_yolo_people_best), # YOLO (people)
high(data_tiny_people_best), # Tiny YOLO (people)
high(data_ssd_people_best), # SSD (people)
high(data_frcnn_people_best), # FRCNN(people)
]


fixed_error_min = [
                   fixed[0] - fixed_min[0],
                   fixed[1] - fixed_min[1],
                   fixed[2] - fixed_min[2],
                   fixed[3] - fixed_min[3],
                ]
fixed_error_max = [
                   fixed_max[0] - fixed[0],
                   fixed_max[1] - fixed[1],
                   fixed_max[2] - fixed[2],
                   fixed_max[3] - fixed[3],
                ]
fixed_error = [fixed_error_min, fixed_error_max]


best_error_min = [
                   best[0] - best_min[0],
                   best[1] - best_min[1],
                   best[2] - best_min[2],
                   best[3] - best_min[3],
                ]
best_error_max = [
                   best_max[0] - best[0],
                   best_max[1] - best[1],
                   best_max[2] - best[2],
                   best_max[3] - best[3],
                ]
best_error = [best_error_min, best_error_max]




x = np.arange(len(labels))  # the label locations
print(x)
width = 0.3  # the width of the bars

fig, ax = plt.subplots()

fig.set_size_inches(7, 3)
#rects1 = ax.bar(x - width*(3/2), fixed, width, label='Fixed', yerr=fixed_error, color='#9ecae1', ecolor='red')
rects1 = ax.bar(x - width/2, fixed, width, label='Fixed', yerr=fixed_error, color='#9ecae1', ecolor='red')
rects2 = ax.bar(x + width/2, best, width, label='Best dynamic', yerr=best_error, color='#3182bd', ecolor='red')
#rects4 = ax.bar(x + width*(3/2), best_cross, width, label='Best cross', yerr=best_cross_error, color='#08519c', ecolor='red')


# Add some text for labels, title and custom x-axis tick labels, etc.
ax.set_ylabel('Accuracy', fontsize=12)
ax.set_title('Aggregate Count', fontsize=18)
ax.set_xticks(x, labels, fontsize=12)
ax.legend( prop={'size': 12} )
#ax.bar_label(rects1, padding=3)
#ax.bar_label(rects2, padding=3)

fig.tight_layout()
plt.savefig('aggregate.pdf')

