import matplotlib.pyplot as plt
import numpy as np


def median(l):
    l.sort()
    idx = int(len(l) / 2)
    return l[idx]

def low(l):
    l.sort()
    idx = int(len(l) / 4)
    return l[idx]

def high(l):
    l.sort()
    idx = int(len(l) * 0.75)
    return l[idx]

labels = ['YOLO\n(cars)', 'YOLO\n(people)', 'Tiny YOLO\n(cars)', 'Tiny YOLO\n(people)', 
            'SSD\n(cars)', 'SSD\n(people)', 'FRCNN\n(cars)', 'FRCNN\n(people)']


# FIXED RESULTS
data_yolo_cars_fixed = [
    1, # seattle-dt-1
    0.9610191, # seattle-traffic
    1, # seattle-dt-2
]
data_yolo_people_fixed = [
    1, # seattle-dt-1
    0.9517597, # seattle-traffic
    0.91796005, # seattle-dt-2
]
data_tiny_cars_fixed = [
    1, # seattle-dt-1 
    0.8100612, # seattle-traffic
    0.98333335, # seattle-dt-2
]
data_tiny_people_fixed = [
    0.9067358, # seattle-dt-1 
    0.89969295, # seattle-traffic
    1, # seattle-dt-2
]
data_ssd_cars_fixed = [
    1, # seattle-dt-1 
    0.7946657, # seattle-traffic
    0.8717949, # seattle-dt-2
]
data_ssd_people_fixed = [
    1, # seattle-dt-1 
    0.7536461, # seattle-traffic
    0.98206276, # seattle-dt-2
]
data_frcnn_cars_fixed = [
    1, # seattle-dt-1 
    0.9726659, # seattle-traffic
    1, # seattle-dt-2
]
data_frcnn_people_fixed = [
    1, # seattle-dt-1 
    0.99942696, # seattle-traffic
    1, # seattle-dt-2
]

# BEST RESULTS
data_yolo_cars_best = [
    1, # seattle-dt-1 
    1, # seattle-traffic
    1, # seattle-dt-2
]
data_yolo_people_best = [
    1, # seattle-dt-1 
    1, # seattle-traffic
    1, # seattle-dt-2
]
data_tiny_cars_best = [
    1, # seattle-dt-1 
    1, # seattle-traffic
    0.8686131, # seattle-dt-2
]
data_tiny_people_best = [
    1, # seattle-dt-1 
    0.99999994, # seattle-traffic
    1, # seattle-dt-2
]
data_ssd_cars_best = [
    1, # seattle-dt-1 
    1, # seattle-traffic
    1, # saettle-dt-2
]
data_ssd_people_best = [
    1, # seattle-dt-1 
    1, # seattle-traffic
    1, # seattle-dt-2
]
data_frcnn_cars_best = [
    1, # seattle-dt-1
    1, # seattle-traffic
    1, # seattle-dt-2
]
data_frcnn_people_best = [
    1, # seattle-dt-1 
    1, # seattle-traffic
    1, # seattle-dt-2
]


fixed = [
median(data_yolo_cars_fixed), # YOLO (cars)
median(data_yolo_people_fixed), # YOLO (people)
median(data_tiny_cars_fixed), # Tiny YOLO (cars)
median(data_tiny_people_fixed), # Tiny YOLO (people)
median(data_ssd_cars_fixed), # SSD (cars)
median(data_ssd_people_fixed), # SSD (people)
median(data_frcnn_cars_fixed), # FRCNN (cars)
median(data_frcnn_people_fixed), # FRCNN(people)
]


best = [ 
median(data_yolo_cars_best), # YOLO (cars)
median(data_yolo_people_best), # YOLO (people)
median(data_tiny_cars_best), # Tiny YOLO (cars)
median(data_tiny_people_best), # Tiny YOLO (people)
median(data_ssd_cars_best), # SSD (cars)
median(data_ssd_people_best), # SSD (people)
median(data_frcnn_cars_best), # FRCNN (cars)
median(data_frcnn_people_best), # FRCNN(people)
]

fixed_min = [
low(data_yolo_cars_fixed), # YOLO (cars)
low(data_yolo_people_fixed), # YOLO (people)
low(data_tiny_cars_fixed), # Tiny YOLO (cars)
low(data_tiny_people_fixed), # Tiny YOLO (people)
low(data_ssd_cars_fixed), # SSD (cars)
low(data_ssd_people_fixed), # SSD (people)
low(data_frcnn_cars_fixed), # FRCNN (cars)
low(data_frcnn_people_fixed), # FRCNN(people)
]
best_min = [
low(data_yolo_cars_best), # YOLO (cars)
low(data_yolo_people_best), # YOLO (people)
low(data_tiny_cars_best), # Tiny YOLO (cars)
low(data_tiny_people_best), # Tiny YOLO (people)
low(data_ssd_cars_best), # SSD (cars)
low(data_ssd_people_best), # SSD (people)
low(data_frcnn_cars_best), # FRCNN (cars)
low(data_frcnn_people_best), # FRCNN(people)
]
fixed_max = [
high(data_yolo_cars_fixed), # YOLO (cars)
high(data_yolo_people_fixed), # YOLO (people)
high(data_tiny_cars_fixed), # Tiny YOLO (cars)
high(data_tiny_people_fixed), # Tiny YOLO (people)
high(data_ssd_cars_fixed), # SSD (cars)
high(data_ssd_people_fixed), # SSD (people)
high(data_frcnn_cars_fixed), # FRCNN (cars)
high(data_frcnn_people_fixed), # FRCNN(people)
]

best_max = [
high(data_yolo_cars_best), # YOLO (cars)
high(data_yolo_people_best), # YOLO (people)
high(data_tiny_cars_best), # Tiny YOLO (cars)
high(data_tiny_people_best), # Tiny YOLO (people)
high(data_ssd_cars_best), # SSD (cars)
high(data_ssd_people_best), # SSD (people)
high(data_frcnn_cars_best), # FRCNN (cars)
high(data_frcnn_people_best), # FRCNN(people)
]


fixed_error_min = [
                   fixed[0] - fixed_min[0],
                   fixed[1] - fixed_min[1],
                   fixed[2] - fixed_min[2],
                   fixed[3] - fixed_min[3],
                   fixed[4] - fixed_min[4],
                   fixed[5] - fixed_min[5],
                   fixed[6] - fixed_min[6],
                   fixed[7] - fixed_min[7],
                ]
fixed_error_max = [
                   fixed_max[0] - fixed[0],
                   fixed_max[1] - fixed[1],
                   fixed_max[2] - fixed[2],
                   fixed_max[3] - fixed[3],
                   fixed_max[4] - fixed[4],
                   fixed_max[5] - fixed[5],
                   fixed_max[6] - fixed[6],
                   fixed_max[7] - fixed[7],
                ]
fixed_error = [fixed_error_min, fixed_error_max]


best_error_min = [
                   best[0] - best_min[0],
                   best[1] - best_min[1],
                   best[2] - best_min[2],
                   best[3] - best_min[3],
                   best[4] - best_min[4],
                   best[5] - best_min[5],
                   best[6] - best_min[6],
                   best[7] - best_min[7],
                ]
best_error_max = [
                   best_max[0] - best[0],
                   best_max[1] - best[1],
                   best_max[2] - best[2],
                   best_max[3] - best[3],
                   best_max[4] - best[4],
                   best_max[5] - best[5],
                   best_max[6] - best[6],
                   best_max[7] - best[7],
                ]
best_error = [best_error_min, best_error_max]




x = np.arange(len(labels))  # the label locations
print(x)
width = 0.3  # the width of the bars

fig, ax = plt.subplots()

fig.set_size_inches(7, 3)
#rects1 = ax.bar(x - width*(3/2), fixed, width, label='Fixed', yerr=fixed_error, color='#9ecae1', ecolor='red')
rects1 = ax.bar(x - width/2, fixed, width, label='Fixed', yerr=fixed_error, color='#9ecae1', ecolor='red')
rects2 = ax.bar(x + width/2, best, width, label='Best dynamic', yerr=best_error, color='#3182bd', ecolor='red')
#rects4 = ax.bar(x + width*(3/2), best_cross, width, label='Best cross', yerr=best_cross_error, color='#08519c', ecolor='red')


# Add some text for labels, title and custom x-axis tick labels, etc.
ax.set_ylabel('Accuracy', fontsize=12)
ax.set_title('Binary Classification', fontsize=18)
ax.set_xticks(x, labels, fontsize=10)
ax.legend( prop={'size': 12}  )
#ax.bar_label(rects1, padding=3)
#ax.bar_label(rects2, padding=3)

fig.tight_layout()
plt.savefig('binary.pdf')

