import matplotlib.pyplot as plt
import numpy as np


def median(l):
    l.sort()
    idx = int(len(l) / 2)
    return l[idx]

def low(l):
    l.sort()
    idx = int(len(l) / 4)
    return l[idx]

def high(l):
    l.sort()
    idx = int(len(l) * 0.75)
    return l[idx]

labels = ['YOLO\n(cars)', 'YOLO\n(people)', 'Tiny YOLO\n(cars)', 'Tiny YOLO\n(people)', 
            'SSD\n(cars)', 'SSD\n(people)', 'FRCNN\n(cars)', 'FRCNN\n(people)']


# FIXED RESULTS
data_yolo_cars_fixed = [
    0.24000005, # seattle-dt-1 
    0.29147643, # seattle-traffic
    0.32784253, # seattle-dt-2
]
data_yolo_people_fixed = [
    0.1441451, # seattle-dt-1
    0.4891263, # seattle-traffic
    0.24494454, # seattle-dt-2
]
data_tiny_cars_fixed = [
    0.23953375, # seattle-dt-1 
    0.29129744, # seattle-traffic
    0.36820826, # seattle-dt-2
]
data_tiny_people_fixed = [
    0.1307772, # seattle-dt-1 
    0.5877283, # seattle-traffic
    0.28397813, # seattle-dt-2
]
data_ssd_cars_fixed = [
    0.24580327, # seattle-dt-1 
    0.19000004, # seattle-traffic
    0.27217972, # seattle-dt-2
]
data_ssd_people_fixed = [
    0.13409331, # seattle-dt-1 
    0.3978755, # seattle-traffic
    0.35237703, # seattle-dt-2
]
data_frcnn_cars_fixed = [
    0.24746107, # seattle-dt-1 
    0.28349236, # seattle-traffic
    0.36614123, # seattle-dt-2
]
data_frcnn_people_fixed = [
    0.12652853, # seattle-dt-1 
    0.38171172, # seattle-traffic
    0.1599782, # seattle-dt-2
]

# BEST RESULTS
data_yolo_cars_best = [
    0.2960623, # seattle-dt-1 
    0.38993856, # seattle-traffic
    0.39240667, # seattle-dt-2
]
data_yolo_people_best = [
    0.24316055, # seattle-dt-1 
    0.5954974, # seattle-traffic
    0.39419064, # seattle-dt-2
]
data_tiny_cars_best = [
    0.28264278, # seattle-dt-1 
    0.467, # seattle-traffic
    0.5328333, # seattle-dt-2
]
data_tiny_people_best = [
    0.27290162, # seattle-dt-1 
    0.7555182, # seattle-traffic
    0.48729947, # seattle-dt-2
]
data_ssd_cars_best = [
    0.29057032, # seattle-dt-1 
    0.3377458, # seattle-traffic
    0.31119698, # seattle-dt-2
]
data_ssd_people_best = [
    0.24056996, # seattle-dt-1 
    0.6720182, # seattle-traffic
    0.44139045, # seattle-dt-2
]
data_frcnn_cars_best = [
    0.30077723, # seattle-dt-1
    0.29866093, # seattle-traffic
    0.42651466, # seattle-dt-2
]
data_frcnn_people_best = [
    0.16834186, # seattle-dt-1 
    0.2237049, # seattle-traffic
    0.22401755, # seattle-dt-2
]


fixed = [
median(data_yolo_cars_fixed), # YOLO (cars)
median(data_yolo_people_fixed), # YOLO (people)
median(data_tiny_cars_fixed), # Tiny YOLO (cars)
median(data_tiny_people_fixed), # Tiny YOLO (people)
median(data_ssd_cars_fixed), # SSD (cars)
median(data_ssd_people_fixed), # SSD (people)
median(data_frcnn_cars_fixed), # FRCNN (cars)
median(data_frcnn_people_fixed), # FRCNN(people)
]


best = [ 
median(data_yolo_cars_best), # YOLO (cars)
median(data_yolo_people_best), # YOLO (people)
median(data_tiny_cars_best), # Tiny YOLO (cars)
median(data_tiny_people_best), # Tiny YOLO (people)
median(data_ssd_cars_best), # SSD (cars)
median(data_ssd_people_best), # SSD (people)
median(data_frcnn_cars_best), # FRCNN (cars)
median(data_frcnn_people_best), # FRCNN(people)
]

fixed_min = [
low(data_yolo_cars_fixed), # YOLO (cars)
low(data_yolo_people_fixed), # YOLO (people)
low(data_tiny_cars_fixed), # Tiny YOLO (cars)
low(data_tiny_people_fixed), # Tiny YOLO (people)
low(data_ssd_cars_fixed), # SSD (cars)
low(data_ssd_people_fixed), # SSD (people)
low(data_frcnn_cars_fixed), # FRCNN (cars)
low(data_frcnn_people_fixed), # FRCNN(people)
]
best_min = [
low(data_yolo_cars_best), # YOLO (cars)
low(data_yolo_people_best), # YOLO (people)
low(data_tiny_cars_best), # Tiny YOLO (cars)
low(data_tiny_people_best), # Tiny YOLO (people)
low(data_ssd_cars_best), # SSD (cars)
low(data_ssd_people_best), # SSD (people)
low(data_frcnn_cars_best), # FRCNN (cars)
low(data_frcnn_people_best), # FRCNN(people)
]
fixed_max = [
high(data_yolo_cars_fixed), # YOLO (cars)
high(data_yolo_people_fixed), # YOLO (people)
high(data_tiny_cars_fixed), # Tiny YOLO (cars)
high(data_tiny_people_fixed), # Tiny YOLO (people)
high(data_ssd_cars_fixed), # SSD (cars)
high(data_ssd_people_fixed), # SSD (people)
high(data_frcnn_cars_fixed), # FRCNN (cars)
high(data_frcnn_people_fixed), # FRCNN(people)
]

best_max = [
high(data_yolo_cars_best), # YOLO (cars)
high(data_yolo_people_best), # YOLO (people)
high(data_tiny_cars_best), # Tiny YOLO (cars)
high(data_tiny_people_best), # Tiny YOLO (people)
high(data_ssd_cars_best), # SSD (cars)
high(data_ssd_people_best), # SSD (people)
high(data_frcnn_cars_best), # FRCNN (cars)
high(data_frcnn_people_best), # FRCNN(people)
]


fixed_error_min = [
                   fixed[0] - fixed_min[0],
                   fixed[1] - fixed_min[1],
                   fixed[2] - fixed_min[2],
                   fixed[3] - fixed_min[3],
                   fixed[4] - fixed_min[4],
                   fixed[5] - fixed_min[5],
                   fixed[6] - fixed_min[6],
                   fixed[7] - fixed_min[7],
                ]
fixed_error_max = [
                   fixed_max[0] - fixed[0],
                   fixed_max[1] - fixed[1],
                   fixed_max[2] - fixed[2],
                   fixed_max[3] - fixed[3],
                   fixed_max[4] - fixed[4],
                   fixed_max[5] - fixed[5],
                   fixed_max[6] - fixed[6],
                   fixed_max[7] - fixed[7],
                ]
fixed_error = [fixed_error_min, fixed_error_max]


best_error_min = [
                   best[0] - best_min[0],
                   best[1] - best_min[1],
                   best[2] - best_min[2],
                   best[3] - best_min[3],
                   best[4] - best_min[4],
                   best[5] - best_min[5],
                   best[6] - best_min[6],
                   best[7] - best_min[7],
                ]
best_error_max = [
                   best_max[0] - best[0],
                   best_max[1] - best[1],
                   best_max[2] - best[2],
                   best_max[3] - best[3],
                   best_max[4] - best[4],
                   best_max[5] - best[5],
                   best_max[6] - best[6],
                   best_max[7] - best[7],
                ]
best_error = [best_error_min, best_error_max]




x = np.arange(len(labels))  # the label locations
print(x)
width = 0.3  # the width of the bars

fig, ax = plt.subplots()

fig.set_size_inches(7, 3)
#rects1 = ax.bar(x - width*(3/2), fixed, width, label='Fixed', yerr=fixed_error, color='#9ecae1', ecolor='red')
rects1 = ax.bar(x - width/2, fixed, width, label='Fixed', yerr=fixed_error, color='#9ecae1', ecolor='red')
rects2 = ax.bar(x + width/2, best, width, label='Best dynamic', yerr=best_error, color='#3182bd', ecolor='red')
#rects4 = ax.bar(x + width*(3/2), best_cross, width, label='Best cross', yerr=best_cross_error, color='#08519c', ecolor='red')


# Add some text for labels, title and custom x-axis tick labels, etc.
ax.set_ylabel('Accuracy', fontsize=12)
ax.set_title('Detection', fontsize=18)
ax.set_xticks(x, labels, fontsize=10)
ax.legend( prop={'size': 12} )
#ax.bar_label(rects1, padding=3)
#ax.bar_label(rects2, padding=3)

fig.tight_layout()
plt.savefig('detection.pdf')

